--
--
--

loadfile("luaScripts/screen_reader_common.inc")();
loadfile("luaScripts/ui_utils.inc")();
loadfile("luaScripts/Library.inc")();

-- Please modify the following lines to customize for your brew
startIngredients = { 
	{ "MediumMalt", 80 }
};

endIngredients = {
	{ "Honey", 50 }
};

startTime = 1195;
endTime = 200;
sealTime = 1200;
beerName = "Beer for spirits";
interDevicePause = 15000;

-- Please do not modify any settings below
idDeviceStatus = 0;
idDeviceLeft = 1;
idDeviceTop = 2;
idDeviceRight = 3;
idDeviceBottom = 4;
idDeviceNum = 5;
idDeviceWidth = 6;
idDeviceHeight = 7;

pass = 0;
default_num_loops = 1;
xyWindowSize = nil;
kettles = {};

function promptForNumbers()
	local scale = 1.0
	
	local z = 0;
	local is_done = nil;
	local value = nil;

	-- Edit box and text display
	while not is_done do
		local y = 40;
		lsPrint(5, y, z, scale, scale, 0xFFFFFFff, "Passes:");
		is_done, num_loops = lsEditBox("passes", 110, y, z, 50, 30, scale, scale, 0x000000ff, default_num_loops);
		if not tonumber(num_loops) then
			is_done = nil;
			lsPrint(10, y+100, z+10, 0.7, 0.7, 0xFF2020ff, "MUST BE A NUMBER");
			num_loops = default_num_loops;
		end
		y = y + 32
		if lsButtonText(170, y-32, z, 100, 0xFFFFFFff, "OK") then
			is_done = 1;
		end
		
		if is_done and (not num_loops and not num_columns and not num_rows) then
			error 'Cancelled';
		end
		
		if lsButtonText(lsScreenX - 110, lsScreenY - 30, z, 100, 0xFFFFFFff, "End Script") then
			error 'Clicked End Script button';
		end
		
		lsDoFrame();
		lsSleep(10);
	end
end

function waitTimer(k,t)
	if not t then
		t = 0;
	end
	srReadScreen();
	timeLeft = srFindImageInRange("Beer/BrewTime.png", k[idDeviceLeft], k[idDeviceTop], k[idDeviceWidth], k[idDeviceHeight], 6000);
	tl = ocrbNumber(timeLeft[0]+49,timeLeft[1]);
	statusScreen("Time Left: " .. tl .. " Secs.");
	lsSleep(500);
	
	while tl do
		checkBreak();
		srReadScreen()
		timeleft = srFindImageInRange("Beer/BrewTime.png", k[idDeviceLeft], k[idDeviceTop], k[idDeviceWidth], k[idDeviceHeight], 6000);
		tl = ocrbNumber(timeLeft[0]+49,timeLeft[1]);
		if tl== t then
			break;
		end
		statusScreen("Time Left: " .. tl.. " Secs.");
		lsSleep(500);
	end
end

function FindAllKettles()
	winKettles = findAllImages("Beer/BeerKettle.png");
	lsPrintln("Number of kettles found: " .. #winKettles);
	
	for c=1, #winKettles do
		kettles[c] = {};
		kettles[c][idDeviceStatus] = 0;
		local kettleBorders = srGetWindowBorders(winKettles[c][0]+5,winKettles[c][1]+5);
		kettles[c][idDeviceLeft] = kettleBorders[0];
		kettles[c][idDeviceTop] = kettleBorders[1];
		kettles[c][idDeviceRight] = kettleBorders[2];
		kettles[c][idDeviceBottom] = kettleBorders[3];
		kettles[c][idDeviceNum] = c;
		kettles[c][idDeviceWidth] = kettleBorders[2]-kettleBorders[0];
		kettles[c][idDeviceHeight] = kettleBorders[3]-kettleBorders[1];
		
		lsPrintln("Kettle " .. c .. " - L: " .. kettles[c][idDeviceLeft] .. " T: " .. kettles[c][idDeviceTop] .. " R: " .. kettles[c][idDeviceRight] .. " B: " .. kettles[c][idDeviceBottom] .. " W: " .. kettles[c][idDeviceWidth] .. " H: " .. kettles[c][idDeviceHeight]);
	end
end

function AddIngredient(i, l, t, w, h)
	srReadScreen();
	btnIngred = srFindImageInRange("Beer/BeerIngredient.png", l, t, w, h, 6000);
	srClickMouseNoMove(btnIngred[0]+5,btnIngred[1]+5);
	lsSleep(200);
	
	srReadScreen();
	winIngred = srGetWindowBorders(xyWindowSize[0]/2, xyWindowSize[1]/2);
	btnIng = srFindImageInRange("Beer/WaterInJugs.png", winIngred[0], winIngred[1], winIngred[2]-winIngred[0], winIngred[3]-winIngred[1],6000);
	srClickMouseNoMove(btnIng[0],btnIng[1]);
	lsSleep(200);

	srReadScreen();
	lsPrintln("Looking for 'Beer/" .. i[1] .. ".png'");
	btnIng = srFindImageInRange("Beer/" .. i[1] .. ".png", winIngred[0], winIngred[1], winIngred[2]-winIngred[0], winIngred[3]-winIngred[1],6000);
	srClickMouseNoMove(btnIng[0],btnIng[1]);
	lsSleep(200);

	srReadScreen();
	btnOK = srFindImageInRange("Beer/IngredientOK.png", winIngred[0], winIngred[1], winIngred[2]-winIngred[0], winIngred[3]-winIngred[1],6000);
	srClickMouseNoMove(btnOK[0]+5, btnOK[1]+5);
	lsSleep(200);

	srReadScreen();
	srKeyEvent("" .. i[2]);
	btnOK = srFindImageInRange("Beer/amountOK.png", winIngred[0], winIngred[1], winIngred[2]-winIngred[0], winIngred[3]-winIngred[1],6000);
	srClickMouseNoMove(btnOK[0]+5, btnOK[1]+5);
	lsSleep(200);

	srReadScreen();
	btnOK = srFindImageInRange("Beer/BeerOKButton2.png", winIngred[0], winIngred[1], winIngred[2]-winIngred[0], winIngred[3]-winIngred[1],6000);
	srClickMouseNoMove(btnOK[0]+5, btnOK[1]+5);
	lsSleep(200);
end

function StartKettles()
	for d=1, #kettles do
		local wL = kettles[d][idDeviceLeft];
		local wT = kettles[d][idDeviceTop];
		local wW = kettles[d][idDeviceWidth];
		local wH = kettles[d][idDeviceHeight];
		
		srReadScreen();
		btnBeer = srFindImageInRange("Beer/BeerButton.png", wL, wT, wW, wH, 6000);
		srClickMouseNoMove(btnBeer[0]+5,btnBeer[1]+5);
		lsSleep(200);
		
		srReadScreen();
		btnBegin = srFindImageInRange("Beer/BeerBeginButton.png", wL, wT, wW, wH, 6000);
		srClickMouseNoMove(btnBegin[0]+5,btnBegin[1]+5);
		lsSleep(200);

		waitTimer(kettles[d],startTime);

		for ing=1, #startIngredients do
			AddIngredient(startIngredients[ing], wL, wT, wW, wH);
		end
		
		kettles[d][idDeviceStatus] = 1;
		
		if d < #kettles then
			sleepWithStatus(interDevicePause, "Pausing before next kettle.");
		end
	end
end

function EndKettles()
	for d=1, #kettles do
		local wL = kettles[d][idDeviceLeft];
		local wT = kettles[d][idDeviceTop];
		local wW = kettles[d][idDeviceWidth];
		local wH = kettles[d][idDeviceHeight];

		waitTimer(kettles[d],endTime);

		for ing=1, #endIngredients do
			AddIngredient(endIngredients[ing], wL, wT, wW, wH);
		end
		
		kettles[d][idDeviceStatus] = 2;
	end
end

function SealKettles()
	for d=1, #kettles do
		local wL = kettles[d][idDeviceLeft];
		local wT = kettles[d][idDeviceTop];
		local wW = kettles[d][idDeviceWidth];
		local wH = kettles[d][idDeviceHeight];

		waitTimer(kettles[d],sealTime);

		srReadScreen();
		btnBeer = srFindImageInRange("Beer/BeerSealButton.png", wL, wT, wW, wH, 6000);
		srClickMouseNoMove(btnBeer[0]+5,btnBeer[1]+5);
		lsSleep(200);

		kettles[d][idDeviceStatus] = 3;
	end
end

function TakeBeer()
	for d=1, #kettles do
		local wL = kettles[d][idDeviceLeft];
		local wT = kettles[d][idDeviceTop];
		local wW = kettles[d][idDeviceWidth];
		local wH = kettles[d][idDeviceHeight];
		local btnTake = nil;
		
		while 1 do
			lsSleep(200);
			checkBreak();
			srReadScreen();
			btnTake = srFindImageInRange("Beer/BeerTakeButton.png", wL, wT, wW, wH, 6000);
			if btnTake ~= nil then
				break
			end
			timeLeft = srFindImageInRange("Beer/BrewTime.png", wL, wT, wW, wH, 6000);
			--lsPrintln(timeleft .. " - " .. wL .. "," .. wT .. "," .. wW .. "," .. wH);
			tl = ocrbNumber(timeLeft[0]+49,timeLeft[1]);
			statusScreen("Time Left: " .. tl.. " Secs.");
			lsSleep(500);
		end
		ClickMouseNoMove(btnTake[0]+5,btnTake[1]+5);
		lsSleep(200);
		
		srReadScreen();
		winIngred = srGetWindowBorders(xyWindowSize[0]/2, xyWindowSize[1]/2);
		btnBegin = srFindImageInRange("Beer/BeerOKButton3.png", winIngred[0], winIngred[1], winIngred[2]-winIngred[0], winIngred[3]-winIngred[1],6000);
		srClickMouseNoMove(btnBegin[0]+5,btnBegin[1]+5);
		lsSleep(200);

		srReadScreen();
		winIngred = srGetWindowBorders(xyWindowSize[0]/2, xyWindowSize[1]/2);
		srKeyEvent(beerName);
		lsSleep(200);
		btnOK = srFindImageInRange("Beer/BeerOKButton4.png", winIngred[0], winIngred[1], winIngred[2]-winIngred[0], winIngred[3]-winIngred[1],6000);
		srClickMouseNoMove(btnOK[0]+5, btnOK[1]+5);
		lsSleep(200);

		kettles[d][idDeviceStatus] = 0;
	end
end

function doit()
	askForWindow();
	promptForNumbers();
	srReadScreen();
	xyWindowSize = srGetWindowSize();
	askForWindow("-- Script written by Walter K. Zydhek\n\nPlease avoid using the mouse while macro is working. Also, minimize chat.");
	
  FindAllKettles();
  
  for pass=1, num_loops do
  	StartKettles();
  	EndKettles();
  	SealKettles();
  	TakeBeer();
  end
end
